package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestAnnotation;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;
import org.bitbucket.bradleysmithllc.etlunit.util.HashMapArrayList;
import org.bitbucket.bradleysmithllc.etlunit.util.MapList;

import java.util.ArrayList;
import java.util.List;

public class ClassAndTestNamesDirectorImpl extends NullClassDirector
{
	private final MapList<String, String> suiteNames = new HashMapArrayList<String, String>();

	private static final String ALL_METHODS = new String();

	public List<String> addClassName(String name)
	{
		return suiteNames.getOrCreate(name);
	}

	public void addClassNameWildcard(String name)
	{
		suiteNames.getOrCreate(name).add(ALL_METHODS);
	}

	@Override
	public response_code accept(ETLTestClass cl) {
		return suiteNames.containsKey(cl.getQualifiedName()) ? response_code.accept : response_code.reject;
	}

	@Override
	public response_code accept(ETLTestMethod mt) {
		List<String> methodNames = suiteNames.get(mt.getTestClass().getQualifiedName());

		if (methodNames != null && methodNames.size() != 0)
		{
			if (methodNames.get(0) == ALL_METHODS)
			{
				return response_code.accept;
			}
			else
			{
				return methodNames.contains(mt.getName()) ? response_code.accept : response_code.reject;
			}
		}

		return response_code.reject;
	}

	@Override
	public response_code accept(ETLTestOperation op) {
		return response_code.accept;
	}
}
