package org.bitbucket.bradleysmithllc.etlunit.io;

import java.io.IOException;
import java.io.OutputStream;

public class BifurcatingOutputStream extends OutputStream
{
	private final OutputStream streama;
	private final OutputStream streamb;

	public BifurcatingOutputStream(OutputStream streamb, OutputStream streama)
	{
		this.streamb = streamb;
		this.streama = streama;
	}

	@Override
	public synchronized void write(int b) throws IOException
	{
		streama.write(b);
		streamb.write(b);
	}

	@Override
	public synchronized void write(byte[] b) throws IOException
	{
		streama.write(b);
		streamb.write(b);
	}

	@Override
	public synchronized void write(byte[] b, int off, int len) throws IOException
	{
		streama.write(b, off, len);
		streamb.write(b, off, len);
	}

	@Override
	public synchronized void flush() throws IOException
	{
		streama.flush();
		streamb.flush();
	}

	@Override
	public synchronized void close() throws IOException
	{
		streama.close();
		streamb.close();
	}
}
